package com.school.project.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.school.project.model.Course;
import com.school.project.model.userRegistration.User;
import com.sun.istack.NotNull;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.List;

@Data
@Entity()
@NoArgsConstructor
@Table(name = "Student")
public class Student {

    @Id
    @Column(name = "student_id")
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Long studentId;

    @NotNull
    @Column(name = "roll_no", unique = true)
    private String rollNumber;

    @NotNull
    @Column(name = "name")
    private String name;

    @NotNull
    @Column(name = "age")
    private Long age;

    @JsonIgnore
    @ManyToMany(fetch = FetchType.LAZY, cascade = {CascadeType.MERGE})
    @JoinTable(
            name = "studentsCourses",
            joinColumns = {@JoinColumn(name = "student_id")},
            inverseJoinColumns = {@JoinColumn(name = "course_id")}
    )
    private List<Course> courseLists;

    @OneToOne
    @MapsId
    @JoinColumn(name = "student_id")
    private User studentAppUser;
}
