package com.school.project.model.userRegistration;


import com.school.project.model.Student;
import com.school.project.model.Teacher;
import com.sun.istack.NotNull;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@Data
@Entity
@NoArgsConstructor
@Table(name = "users")
public class User {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "user_id")
    private Long userId;

    @NotNull
    @Column(name = "user_email", unique = true)
    private String email;

    @NotNull
    @Column(name = "user_password")
    private String password;

    @ManyToOne
    @JoinColumn(name = "role_id")
    @NotNull
    private Role role;

    @OneToOne(mappedBy = "studentAppUser", cascade = {CascadeType.MERGE})
    @PrimaryKeyJoinColumn
    private Student studentUser;

    @OneToOne(mappedBy = "teacherAppUser", cascade = {CascadeType.MERGE})
    @PrimaryKeyJoinColumn
    private Teacher teacherUser;

    @OneToOne(mappedBy = "adminAppUser", cascade = {CascadeType.MERGE})
    @PrimaryKeyJoinColumn
    private Admin adminUser;

}
