package com.school.project.service.course;

import com.school.project.dto.CourseDTO;
import com.school.project.mapper.CourseMapper;
import com.school.project.repository.modelRepositery.CourseRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;

@Service
public class CourseServiceImp implements CourseService {

    @Autowired(required = true)
    public CourseRepository courseRepository;

    @Autowired
    public CourseMapper courseMapper;

    @Override
    public CourseDTO saveCourse(CourseDTO courseDTO) {
        return courseMapper.courseModelToDTO(
                courseRepository.save(
                        courseMapper.courseDTOToModel(courseDTO)));
    }

    @Transactional
    @Override
    public List<CourseDTO> readAllCourse() {
        return courseMapper.courseModelToDTO(courseRepository.findAll());
    }

    @Override
    public CourseDTO readCourseById(Long id) {
        return courseMapper.courseModelToDTO(courseRepository.findById(id).get());
    }

    @Override
    public CourseDTO updateCourseById(CourseDTO courseDTO, Long id) {
        CourseDTO dto = readCourseById(id);

        if (courseDTO.getTitle() != null) {
            dto.setTitle(courseDTO.getTitle());
        }
        if (courseDTO.getTeacherList() != null) {
            dto.setTeacherList(courseDTO.getTeacherList());
        }
        if (courseDTO.getStudentList() != null) {
            dto.setStudentList(courseDTO.getStudentList());
        }

        return courseMapper.courseModelToDTO(
                courseRepository.save(
                        courseMapper.courseDTOToModel(dto)));
    }

    @Override
    public void deleteCourseById(Long id) {
        courseRepository.deleteById(id);
    }
}
